local frame = CreateFrame("Frame")

function ACCVOXMSG(msg)
	local ACCVOXType = ACCVOXMode
	if ACCVOXMode=="SELF" then
		print(msg)
		return
	elseif ACCVOXMode == "YELL" then
		ACCVOXType="YELL"
	elseif ACCVOXMode=="RAID_WARNING" or ACCVOXMode == "GROUP" then
		if IsInRaid() and ACCVOXMode=="RAID_WARNING" and (IsEveryoneAssistant() or UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") or UnitIsRaidOfficer("player")) then
			ACCVOXType = "RAID_WARNING"
		elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			ACCVOXType = "INSTANCE_CHAT"
		elseif IsInRaid() then
			ACCVOXType = "RAID"
		elseif IsInGroup() then
			ACCVOXType = "PARTY"
		end
	end
	SendChatMessage(msg,ACCVOXType)
end

local function handler (msg)
	msg=string.upper(msg)
	if msg == 'ON' or msg == 'OFF' then
		ACCVOX = (msg == 'ON')
		if ACCVOX then
			frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end
		print("ACCVOX is now |cffff0000"..(ACCVOX and "On" or "Off").."|r.")
		
	elseif msg == 'SAY' or msg == 'GROUP' or msg == 'SELF' or msg == 'YELL' then
		ACCVOXMode = msg
		print("ACCVOX is now announcing to |cffff0000"..ACCVOXMode.."|r.")
		
	elseif msg=="RW" or msg=="RAIDWARNING" then
		ACCVOXMode="RAID_WARNING"
		print("ACCVOX is now announcing to |cffff0000"..ACCVOXMode.."|r.")
		
	elseif msg == 'TEST' then
		ACCVOXMSG("ACCVOX Test Message!")
		
	else
		print("ACCVOX is |cffff0000"..(ACCVOX and "On" or "Off").."|r and announcing to: |cffff0000"..ACCVOXMode.."|r.\nCommands:\non/off,say/yell/group/self/rw,test")
	end
end

SlashCmdList["ACCVOX"] = handler;
SlashCmdList["WL2"] = handler;
SLASH_ACCVOX1 = "/ACCVOX"
SLASH_WL21 = "/AV"

local warpSpells = {
	[2825] = true, -- Bloodlust
    [32182] = true, -- Heroism
	[80353] = true, -- Time Warp
	[90355] = true, -- hysteria
	[160452] = true, -- netherwinds
	[230935] = true, -- drums of mountain
	[178207] = true, -- drums of fury
	[146555] = true, -- drums of rage
}

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")

frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		if ACCVOX == nil then
			ACCVOX = true
		end
		
		if ACCVOXMode == nil then
			ACCVOXMode = "GROUP"
		elseif ACCVOXMode ~= string.upper(ACCVOXMode) then
			ACCVOXMode = string.upper(ACCVOXMode)
		end
		
		if ACCVOX == true then
			frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end

	else
		local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, _ = ...		
		local pNum=GetNumGroupMembers()
		if ACCVOX and warpSpells[spellID] and pNum > 0 and (event=="SPELL_CAST_SUCCESS") then
			if (UnitPlayerOrPetInParty(sourceName) or UnitPlayerOrPetInRaid(sourceName)) then
				if UnitIsPlayer(sourceName) then
					ACCVOXMSG("AccelerandoVox: "..sourceName.." cast "..GetSpellLink(spellID).."!")
				else
					if UnitIsUnit("pet", sourceName) then
						sourceName = ("%s"):format(UnitName("player"))
					elseif IsInRaid() then
						for x = 1, pNum do
							if UnitIsUnit(("raidpet%i"):format(x), sourceName ) then
								sourceName = ("%s"):format(UnitName(("raid%i"):format(x)))
								break
							end
						end
					elseif IsInGroup() then 
						for x = 1, pNum do
							if UnitIsUnit(("partypet%i"):format(x), sourceName ) then
								sourceName = ("%s"):format(UnitName(("party%i"):format(x)))
								break
							end
						end
					end
					ACCVOXMSG("AccelerandoVox: "..sourceName.."\'s pet cast "..GetSpellLink(spellID).."!")
				end
			end
		end
	end
end)